function [patch,kp_out]=patch_normalize(img,kp,r)

[lines,columns]=size(img);
% alpha=kp(3);
% a=round(kp(4)*k);
% b=round(kp(5)*k);
% h=min([kp(1)-1,lines-kp(1)]);
% w=min([kp(2)-1,columns-kp(2)]);
% R=min(min(h,w),a);
% patch=img(kp(1)-R:kp(1)+R,kp(2)-R:kp(2)+R);
% patch=imrotate(patch,alpha/pi*180,'bicubic','crop');
% R=round(a/b*r);
% patch=imresize(patch,[2*R+1,2*r+1],'bicubic');
% patch=patch(R-r+1:R+r+1,:);

% rr=r;
% r=60;

patch=img(kp(1)-r:kp(1)+r,kp(2)-r:kp(2)+r);
h=fspecial('gaussian',2*r+1,r/3);
h=h/max(max(h));
patch=patch.*h;
% patch=imfilter(patch,h);

NBINS=36;
dx_filter = [-0.5 0 0.5];
dy_filter = dx_filter';
gradient_x = imfilter(patch, dx_filter);
gradient_y = imfilter(patch, dy_filter);
magnitudes =sqrt( gradient_x.^2 + gradient_y.^2);
angles = mod(atan(gradient_y ./ (eps + gradient_x))+0.5*(1-sign(gradient_x))*pi + 2*pi, 2*pi);
angles(isnan(angles))=pi/2;
sigmaw=r/4;
histo = zeros(1, NBINS);
x=r+1;
y=r+1;
xp=floor(x+0.5);
yp=floor(y+0.5);
iii=0;
for xs = xp - max(r, xp-1): min((columns - 2), xp + r)
    for ys = yp - max(r, yp-1) : min((lines-2), yp + r)
        iii=iii+1;
        dx = (xs - x);
        dy = (ys - y);
        if dx^2 + dy^2 <= r^2 % the points are within the circle
            wincoef = exp(-(dx^2 + dy^2)/(2*sigmaw^2));
            bin = round( NBINS *  angles(ys, xs)/(2*pi) + 0.5);
            histo(bin) = histo(bin) + wincoef * magnitudes(ys, xs);
        end
    end
end
%     histo
%     figure;hist(histo);
%     figure;imshow(octave);
theta_max = max(histo);
theta_indx = find(histo==theta_max);
% theta_indx = find(histo> 0.8 * theta_max);
theta = 2*pi * theta_indx(1) / NBINS;
if(kp(4)~=theta)
    error=1
end

% r=rr;
% patch=img(kp(1)-r:kp(1)+r,kp(2)-r:kp(2)+r);
% h=fspecial('gaussian',2*r+1,r/3);
% h=h/max(max(h));
% patch=patch.*h;

patch=imrotate(patch,theta/pi*180,'bicubic','crop');