function [descriptor,kp]=cal_descr(img,kp,r,Q,method,rotate)

img_t=img';
num_blk=size(Q,2);
[lines,columns]=size(img);
% N=size(Q(1).value,3);
if(strcmp(method,'SURF'))
    r=r+4;
    nD=4;
% elseif(strcmp(method,'EP'))
%     nD=n;
else
    nD=size(Q(1).value,2);
end

% h=fspecial('gaussian',2*r+1,r/2);
% h=h/max(max(h));
% imgs=imfilter(img,h);
% % kp=my_orientation(img,kp,r,kk,0.99);

if(rotate&&size(kp,2)<4)
    kp=orientation(img,kp,r,kk,0.85);
end
num=size(kp,1);
descriptor=zeros(num_blk*nD,num);
index=logical(ones(num,1));

for k=1:num
    if(size(kp,2)<=4)
        patch=img(kp(k,1)-r:kp(k,1)+r,kp(k,2)-r:kp(k,2)+r);
%         patch=img_t(kp(k,2)-r:kp(k,2)+r,kp(k,1)-r:kp(k,1)+r);
%         patch=img_t(kp(k,2)-kp(k,3):kp(k,2)+kp(k,3),kp(k,1)-kp(k,3):kp(k,1)+kp(k,3));
%         patch=imresize(patch,[2*r+1,2*r+1]);
        hh=fspecial('gaussian',2*r+1,r/2);
        patch=patch.*hh;
        if(size(kp,2)==4)
%             patch=imrotate(patch,kp(k,4)/pi*180,'crop');
            patch=imrotate(patch,kp(k,4)/pi*180,'bicubic','crop');
        end
%         patch=patch_normalize(img,kp(k,:),r,kk);
    else
        patch=patch_normalize(img,kp(k,:),r);
    end
    patch=patch';
    window=logical(ones(2*r+1));
    b=patch(window);
    descr=zeros(num_blk*nD,1);
    for i=1:num_blk
        if(strcmp(method,'SURF'))
            dx=Q(i).x'*b;
            mdx=abs(Q(i).x'*b);
            dy=Q(i).y'*b;
            mdy=abs(Q(i).y'*b);
            descr((i-1)*nD+1:i*nD)=[sum(dx);sum(mdx);sum(dy);sum(mdy)];
        else
            for ii=1:size(Q(i).value,2)
                qb=Q(i).value(:,1:ii)'*b;
            end
            
%             qb=Q(i).value(:,:)'*b;
            sig=sign(qb);
            descr((i-1)*nD+1:i*nD)=abs(qb);
        end
    end
    descriptor(:,k)=descr/norm(descr);
end
kp=kp(index,:);
descriptor=descriptor(:,index);