function [descriptor,kp]=descriptor(img,kp,method,n1,n2,r,dr,m,rotate,Q)

%descriptor Compute feature vectors using different bases
%   method: only "EP" and "SURF" is now avalable

tic
if(nargin<9)
    switch method
        case 'SURF'
            Q=SURF_basis(r);
        case 'EP'
            Q=EP_basis(r,n1,n2);
%         case 'DoG'
%             Q=DoG_basis(r,N);
%         case 'Gabor'
%             Q=Gabor_basis(r,N);
    end
    Q=basisTrans(Q,r,dr,method,m);
end
% displayBases(Q,n1,n2);
% kp=do_orientation(oframes,imgs,3,1,r/4) ;
[descriptor,kp]=cal_descr(img,kp,r,Q,method,rotate);
toc