function [n_all,n_true,n_false]=drawMatching(img1,img2,kp1,kp2,matched,TH,mode)

if(nargin<7)
    TH=0.75;
end
if(nargin<8)
    mode=0;
end
% img1=drawKP(img1,kp1);
% img2=drawKP(img2,kp2);
ind=(matched(:,6)<TH);
matched=matched(ind,:);
n_all=sum(ind);
ind_true=(matched(:,7)==1);
n_true=sum(ind_true);
n_false=n_all-n_true;
[lines1,rows1]=size(img1);
[lines2,rows2]=size(img2);
lines=max(lines1,lines2);
rows=max(rows1,rows2);
I1=zeros(lines,rows);
I1(1:lines1,1:rows1)=img1;
I2=zeros(lines,rows2);
I2(1:lines2,1:rows2)=img2;

% I1=img1(49:118,36:105);
% I2=img2(49:118,36:105);

figure;
imagesc([I1,I2]);
colormap gray;
hold on;
if(mode==0)
    colorSet=['r','m','c','b','y','g'];
    c=1;
    for i=1:size(matched,1)
%         i
% if(i==123)
%     i;
% end
%         imagesc([I1,I2]);
%         hold on;
%         color=colorSet(mod(c,6)+1);
        color='c';
%         if(matched(i,2)>=36&&matched(i,2)<=105)%&&matched(i,1>=49)&&matched(i,1)<=118&&matched(i,4)>=36&&matched(i,4)<=105&&matched(i,3>=49)&&matched(i,3)<=118)
%             plot([matched(i,2)-35,matched(i,4)+70-35],[matched(i,1)-48,matched(i,3)-48],color);
%         end
        
%         plot([matched(i,2),matched(i,4)],[matched(i,1),matched(i,3)+lines],color,'linewidth',2);
        plot([matched(i,2),matched(i,4)+rows],[matched(i,1),matched(i,3)],color,'linewidth',1);
        for j=1:size(kp2,1)
            if(kp1(j,1:2)==matched(i,1:2))
                break;
            end
        end
%         if(isAffine)
%             ellipse(kp1(j,2),kp1(j,1),kp1(j,4),kp1(j,5),kp1(j,3),'r');
%         else
%             ellipse(kp1(j,2),kp1(j,1),kp1(j,3),kp1(j,3),0,'r');
%         end
        
        for k=1:size(kp2,1)
            if(kp2(k,1:2)==matched(i,3:4))
                break;
            end
        end
%         if(isAffine)
%             ellipse(kp2(k,2)+rows,kp2(k,1),kp2(k,4),kp2(k,5),kp2(k,3),'r');
%         else
%             ellipse(kp2(k,2)+rows,kp2(k,1),kp2(k,3),kp2(k,3),0,'r');
%         end
%         c=c+1;
%         hold off;
    end
elseif(mode==1)
    colorSet=['r','c'];
    for i=1:size(matched,1)
        color=colorSet(matched(i,7)+1);
        plot([matched(i,2),matched(i,4)+rows],[matched(i,1),matched(i,3)],color);
    end
end
